using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;


namespace so905i
{
    public partial class Form1 : Form
    {
        struct mp3Data
        {
            public string filepath;//mp3t@C̃pX
            public string dir_name;//D&D̃tH_
        }
        private mp3Data[] mp3 = new mp3Data[1];//[t@C]
        private string drive;//hCu
        private string playlist_name;//vCXg
        public Form1()
        {
            InitializeComponent();
        }

        private void listBox1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
            else
                e.Effect = DragDropEffects.None;
        }

        private void listBox1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            string[] path_chk = (string[])e.Data.GetData(DataFormats.FileDrop, false);//tH_t@C
            if (mp3.Length == 1)
                listBox1.Items.Clear();
            drive = Directory.GetDirectoryRoot(path_chk[0]);//̓t@C̃[gfBNg
            for (int i = 0; i < path_chk.Length; i++)
            {
                string[] dir = path_chk[i].Split('\\');//fBNgpX\\Ƃɕ
                if (dir[1] == "MUSIC" || dir[4] == "MUSIC")//~[WbNtH_ɂ
                {
                    if (File.Exists(path_chk[i]) && Path.GetExtension(path_chk[i]) == ".mp3")//mp3t@ĈƂ
                    {
                        mp3[mp3.Length-1].dir_name = dir[dir.Length - 2];//mp3t@C̓ĂtH_
                        mp3[mp3.Length - 1].filepath = path_chk[i].Remove(0, 2);//mp3t@C̃pX
                        listBox1.Items.Add(mp3[mp3.Length - 1].filepath);
                        Array.Resize(ref mp3, mp3.Length + 1);//mp3z傫
                    }
                    if (Directory.Exists(path_chk[i]))//tH_̂Ƃ
                    {
                        string[] temp = Directory.GetFiles(path_chk[i], "*.mp3", SearchOption.AllDirectories);//tH_ɂt@C.mp3̂St@C
                        Array.Resize(ref mp3, mp3.Length + temp.Length);//mp3z傫
                        int k = 0;
                        for (int j = (mp3.Length - temp.Length - 1); j < mp3.Length-1; j++)
                        {
                            mp3[j].dir_name = dir[dir.Length - 1];//tH_
                            mp3[j].filepath = temp[k++].Remove(0, 2);//mp3t@C̃pX
                            listBox1.Items.Add(mp3[j].filepath);
                        }
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string[] playlist = new string[1];
            if (mp3.Length == 1)
                return;
            listBox1.Items.Clear();
            button1.Enabled = button2.Enabled = textBox1.Enabled = radioButton1.Enabled = radioButton2.Enabled = false;//ݒ̕ύX֎~
            Array.Resize(ref mp3, mp3.Length - 1);//܂̔z
            progressBar1.Minimum = 0;
            progressBar1.Maximum = mp3.Length;
            playlist_name = textBox1.Text;

            string winDir = System.Environment.GetEnvironmentVariable("windir");
            if (!Directory.Exists(drive + "PRIVATE\\DOCOMO\\MMFILE\\MUSIC\\PLAYLIST"))//PLAYLISTtH_Ȃ
                System.IO.Directory.CreateDirectory(drive + "PRIVATE\\DOCOMO\\MMFILE\\MUSIC\\PLAYLIST");//tH_

            if (radioButton1.Checked)//vCXgɃtH_𗘗pƂ
                for (int i = 0; i < mp3.Length; i++)
                    if (i == 0 || i > 0 && mp3[i].dir_name != mp3[i - 1].dir_name)//vCXgωƂ
                    {
                        //vCXg.m3űt@CăvCXg
                        using (System.IO.FileStream hStream = System.IO.File.Create(drive + "PRIVATE\\DOCOMO\\MMFILE\\MUSIC\\PLAYLIST\\" + mp3[i].dir_name + ".m3u"))
                            if (hStream != null)//쐬ɕԂ FileStream 𗘗pĕ
                                hStream.Close();
                        listBox1.Items.Add("vCXg" + "u" + mp3[i].dir_name + "v" + "쐬܂B");
                    }
            if (radioButton2.Checked)//vCXgɔCӂ̖OƂ
            {
                //vCXg.m3űt@CăvCXg
                using (System.IO.FileStream hStream = System.IO.File.Create(drive + "PRIVATE\\DOCOMO\\MMFILE\\MUSIC\\PLAYLIST\\" + playlist_name + ".m3u"))
                    if (hStream != null)//쐬ɕԂ FileStream 𗘗pĕ
                        hStream.Close();
                listBox1.Items.Add("vCXg" + "u" + playlist_name + "v" + "쐬܂B");
            }
            for (int i = 0; i < mp3.Length; i++)
            {
                progressBar1.Value = i;//vOXo[\
                writer(i);//vCXg쐬
            }
            button1.Enabled = button2.Enabled = radioButton1.Enabled = radioButton2.Enabled = true;//ݒ̕ύX
            if(radioButton2.Checked)
                textBox1.Enabled = true;
            mp3 = new mp3Data[1];
            progressBar1.Value = 0;//vOXo[
        }

        private void writer(int num)
        {
            if (radioButton1.Checked)
                playlist_name = mp3[num].dir_name;
            //vCXg֒ǉ
            StreamWriter writer = new StreamWriter(drive + "PRIVATE\\DOCOMO\\MMFILE\\MUSIC\\PLAYLIST\\" + playlist_name + ".m3u", true, System.Text.Encoding.GetEncoding(932));
            writer.WriteLine(mp3[num].filepath);
            writer.Close();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            textBox1.Enabled = false;
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            textBox1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            mp3 = new mp3Data[1];
        }

    }
}